unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, Menus, Math, ExtCtrls, ComCtrls;

type
  TGrille = array [1..9,1..9] of String[1];
  // State de la grille Sudoku
  TSuState = (ssSol,  //  la grille  rsoudre gnre par l'application
              ssSaisie, // en saisie
              ssSolAu   // Solultion par application
              );
  TFrGrille = class(TForm)
    StringGrid1: TStringGrid;
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StringGrid1MouseLeave(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MenuItemPopupClik(Sender: TObject);
  private
    { Dclarations prives }
    function ValideContrainte(Line, Col : Integer; MyTab : TGrille):Boolean;// LE CONTENUE DE LA CELLULE EST VALIDE ?
  public
    { Dclarations publiques }
    Bloque : array [1..9,1..9] of Boolean;// la cellule [i,j] : modifiable
    //Colors : array [1..9,1..9] of TColor;// COULEUR DES CELLULES
    SuState : TSuState; //
    //Tableau : TGrille;
    //Solution : TGrille;
    TempTap : TGrille;// LE GRILLE EN COURS
    SuFichier : TFileName;// LE FICHIER EN COURS



    procedure LoadformStrings(S : TStringList);
    procedure LoadFromFile(Fichier : string); //

    function SaveToStrings(Sol : Boolean) : TStringList; // sol = (Sauvegarde de la solution ?)
    procedure SaveToFile(Fichier : string;Sol : Boolean);// sol = (Sauvegarde de la solution ?)

    function condidat(MyTab :TGrille;Line,Col : Integer;SS :string): string;// donne les condidat pour la cellule (Line,Col) (les valeurs possibles)
    function Alea : string;// generer un chaine alea contient de 1  9 (ordre alea)
    // la fonction principale : pour generer et completer des grilles
    function Generergrille(Var MyTab : TGrille; GAlea : Boolean = true):Boolean;// POUR GENERER UN GRILL

    procedure Masquage(MyTab : TGrille;NbrMasque : Integer; Var MaskedTab : TGrille);// POUR MASQUER DES CELLULES
    procedure AffectationTableau(T1 : TGrille;Var T2 : TGrille);// POUR COPIER UN GRILLE DAND UN AUTRE
    procedure IncCell(Var Line,Col : Integer);// INCREMENTER LA CELLULE ( LA SUIVANTE)
    procedure DecCell(Var Line,Col : Integer);// DECREMENTER LA CELLULE ( LA PRECEDENTE)
    procedure ViderGrille(var MayTap : TGrille); // EFFACER LE ONTENU
    procedure ViderGrilleSol(var MayTap : TGrille); // EFFACER LA SOLUTION


    function IsEmpetyGrid(MyTap : TGrille) : Boolean;
    function IsFullGrid(MyTab : TGrille) : Boolean;

  end;

var
  FrGrille: TFrGrille;


    Col,Row : Integer;


implementation

uses Types;

{$R *.dfm}
function TFrGrille.ValideContrainte(Line, Col : Integer; MyTab : TGrille):Boolean;
var
 i,j : Integer;
 x,y: Integer;
 V : String[1];
begin
  Result := False;

  V := MyTab[Line,Col];
  for x := 1 to 9 do
    begin
      if x = Col then Continue;
      if V = MyTab[Line,x] then Exit;
    end;

  for x := 1to 9 do
    begin
      if x = Line then Continue;
      if V = MyTab[x,Col] then Exit;
    end;

  i := ((Line -1) div 3) * 3 +1;
  j := ((Col-1) div 3) * 3 +1;

  for x := i to i+2 do
    for y := j to j+2 do
      begin
        if ((x = Line) and (y = Col)) then Continue;
      if V = MyTab[x,y] then Exit;
      end;
  Result := True;
end;


procedure TFrGrille.AffectationTableau(T1: TGrille; var T2: TGrille);
var
  Line,Col : Integer;
begin
   for Line := 1 to 9 do
     for Col := 1 to 9 do
       T2[Line,Col] := T1[Line,Col];
end;

function TFrGrille.Alea: string;
var
  S : string;
  j,i : Integer;
begin
     Randomize;
     S := '123456789';
     Result:= '';
     for i := 1 to 8 do
       begin
          j:= RandomRange(1,Length(S));
          Result := Result + S[j];
          Delete(S,j,1)
       end;
     Result := Result + s;
end;

function TFrGrille.condidat(MyTab :TGrille;Line, Col: Integer;SS :string): string;
var
  s : string;
  i,j,p : Integer;
  x,y : Integer;
begin
   S := SS;
   for I := 1 to 9 do
     begin
       if MyTab[Line,i] = '' then Continue;
       if i = Col then Continue;

       p := Pos(MyTab[Line,i],S);
       if P> 0  then Delete(S,P,1);
     end;

   for I := 1 to 9 do
     begin
       if MyTab[i,Col] = '' then Continue;
       if i = Line then Continue;

       p := Pos(MyTab[i,Col],S);
       if P> 0  then Delete(S,P,1);
     end;

     x := ((Line-1) div 3)*3 +1;
     y := ((Col-1) div 3)*3 +1;

     for I := x to x+2 do
       for j := y to y+2 do
     begin
       if MyTab[i,j] = '' then Continue;
       if (i = Line) and (j = Col) then Continue;
       p := Pos(MyTab[i,j],S);
       if P> 0  then Delete(S,P,1);
     end;
   Result := S;
end;

procedure TFrGrille.DecCell(var Line, Col: Integer);
begin
if Col <= 1 then
  begin
    Col := 9;
    Line := Line-1;
  end else
  begin
    Col := Col -1;
  end;
end;



procedure TFrGrille.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := caFree;
end;

function TFrGrille.Generergrille(Var MyTab: TGrille; GAlea : Boolean = true): Boolean;
var
  Col,Line : Integer;
  S :string ;
  Rep : array [1..9,1..9] of Integer;//N d'ordre (index dans la chain alea de la ligne) de condidat utilis pour chaque cellule (pour liminer ce choix au cas de retour arriere)

  x,y : Integer;
  Stop : Boolean; // variable utilise pour sortir de la boucle au cas de stagnation (solution immpossible)
  TabAlea : array [1..9] of string;// sauvgarder la chain alea pour chaque ligne
begin
  // initialisation
  Result := True;
  Stop := False;

  for Line := 1 to 9 do
    for Col := 1 to 9 do
      begin
       Rep[Line,Col] := 1;
        Bloque[Line,Col] := (MyTab[Line,Col] <> '');// bloquer les cell. de depart = n'autoriser pas la modification

      end;
  if GAlea then
    begin
      // generer une chaine alea pour chaque line
      for Line := 1 to 9 do
        TabAlea[Line] := Alea;
    end else
    begin
      for Line := 1 to 9 do
        TabAlea[Line] := '123456789';
    end;

  Line := 1;
  while Line <=9 do
   begin
     Col := 1;
     While Col <=9 do
       begin

         while(Bloque[Line,Col]) do
           begin
             IncCell(Line,Col);
             if  ( not (Line in [1..9] )) or (not (Col in [1..9])) then
               begin
                 //ShowMessage('Pas de solution !!!');
                 Stop := True;
                 Break;
               end;
           end;
         if Stop then Break;

         s := condidat(MyTab,Line,Col,TabAlea[line]);

         if (S = '') or(rep[Line,Col] > Length(s)) then
           begin

            repeat
               DecCell(Line,Col);
               if (not(Col in [1..9])) or (not(Line in [1..9])) then
                 begin
                   //ShowMessage('pas de solution !!');
                   Stop := True;
                   Break;
                 end;
            until not Bloque[Line,Col];
            if Stop then Break;

             Rep[Line,Col] := Rep[Line,Col] + 1;
              x := Line;
              y := Col;
              repeat
                IncCell(x,y);
                if (x in [1..9]) and(y in [1..9]) then
                  begin
                    if not(Bloque[x,y]) then break;
                  end else break;

              until False;
            if (x in [1..9]) and(y in [1..9]) then Rep[x,y] := 1;
           MyTab[Line,Col]:= '';


           Continue;
           end;
         MyTab[Line,Col] := S[rep[line,Col]];
          Inc(Col);
          //S1 := '';
       end;
     if Stop then Break;

     Inc(Line);
   end;

   for Line := 1 to 9 do
     for Col := 1 to 9 do
       begin
         if MyTab[Line,Col] = '' then
           begin
             Result := False;
             Exit;
           end;
       end;

end;

procedure TFrGrille.IncCell(var Line, Col: Integer);
begin
if col >=9 then
  begin
    Col := 1;
    Line := Line + 1;
  end else
  begin
    Col := Col + 1;
  end;
end;

function TFrGrille.IsEmpetyGrid(MyTap: TGrille): Boolean;
 var
   Col,Line : Integer;
begin
  Result := True;
  for Line := 1 to 9 do
    for Col := 1 to 9 do
       if MyTap[Line,Col] <> '' then
         begin
           Result := False;
           Exit;
         end;

end;

function TFrGrille.IsFullGrid(MyTab: TGrille): Boolean;
var
   Col,Line : Integer;
begin
  Result := True;
  for Line := 1 to 9 do
    for Col := 1 to 9 do
       if MyTab[Line,Col] = '' then
         begin
           Result := False;
           Exit;
         end;

end;

procedure TFrGrille.LoadFromFile(Fichier: string);
  var
    SList : TStringList;
begin
   SList := TStringList.Create;
   try
   SList.LoadFromFile(Fichier);
   LoadformStrings(SList);
   Except
      MessageDlg('Impossible de lire le fichier !!',mtError,[mbOK],0);
      SList.Free;
      Exit;
   end;

SuFichier := Fichier;
Caption := ExtractFileName(SuFichier);
SList.Free;

end;

procedure TFrGrille.LoadformStrings(S: TStringList);
var
  Line,Col: Integer;
  RowsCount, ColsCount : Integer;
  SS : string;
  L: Integer;
begin
  if S.Count = 0 then Exit;

  RowsCount := S.Count;
  // se limiter  9 lihnes
  if RowsCount > 9 then RowsCount := 9;
  For Line := 0 to RowsCount-1 do
    begin
      SS := S[Line];
      ColsCount := Length(SS);
      // se limiter  9 colonnes
      if ColsCount > 9 then ColsCount := 9;
      For Col := 0 to ColsCount - 1 do
        begin
          if not (SS[Col+1]in ['1'..'9']) then
            begin
              TempTap[Line+1,Col+1] := '';
              Bloque[Line+1,Col+1] := False;// les cellules vides seront modifiables
            end else
            begin
              TempTap[Line+1,Col+1] := SS[Col+1];
              Bloque[Line+1,Col+1] := True;// les cellules non vides ne seront pas modifiables
            end;
        end;
      // completer la grille par des vides
      if ColsCount < 9 then
        begin
          For Col := ColsCount to 8 do
            TempTap[Line+1,Col+1] := '';
        end;

    end;
  // completer la grille par des vides
  if RowsCount < 9 then
    begin
      For Line := RowsCount to 8 do
        For Col := 0 to 8 do
           TempTap[Line+1,Col+1] := '';

    end;
  // verifier si la grille de dpart est correct, effacer les cellule incorrect

  for L := 1 to 9 do
    for Col := 1 to 9 do
      begin
        if Trim(TempTap[L,Col]) = '' then Continue;
        
        if not ValideContrainte(L,Col,TempTap) then
          begin
            MessageDlg(Format('Le contenue de la cellue (%d,%d) est incorrect :!!',[L,Col]),mtWarning,[mbOK],0);
            TempTap[L,Col] := '';
            Bloque[L,Col] := False;
          end;
      end;

end;

procedure TFrGrille.Masquage(MyTab: TGrille; NbrMasque: Integer; Var MaskedTab : TGrille);
var
  Line,Col : Integer;
  nbr : Integer;// nbr de cell masquees
begin
   for Line := 1 to 9 do
     for Col := 1 to 9 do
       MaskedTab[Line,Col] := MyTab[Line,Col];

  nbr := 0;
  Randomize;
  RandSeed := RandomRange(1,200);
  // choisir un cell alea, masquer s'il n'est pas masquer
  Repeat
     Line := RandomRange(1,10);
     Col := RandomRange(1,10);

     if MaskedTab[Line,Col] <> '' then
       begin
        MaskedTab[Line,Col] := '';
        nbr := nbr + 1;
       end;
  Until nbr >= NbrMasque;
end;


procedure TFrGrille.MenuItemPopupClik(Sender: TObject);
var
  Col,Line : Integer;
  GRect : TGridRect;
  Key : Char;
begin
  GRect := StringGrid1.Selection;
  Col := GRect.Left;
  Line := GRect.Top;
  if (Col < 1) or (Line < 1) then Exit;
  Key :=  TMenuItem(Sender).Caption[2];
  StringGrid1KeyPress(StringGrid1,Key);

end;



procedure TFrGrille.SaveToFile(Fichier: string; Sol: Boolean);
var
  List : TStringList;
begin
  List := TStringList.Create;
  List.DelimitedText := SaveToStrings(Sol).DelimitedText;
  if List.Count <=0 then exit;
  try
    List.SaveToFile(Fichier);
    SuFichier := Fichier;
    Caption := ExtractFileName(SuFichier);
    List.Free;
  Except
     MessageDlg('Impossible d''enregistrer !!',mtError,[mbOK],0);
  end;
end;

function TFrGrille.SaveToStrings(Sol: Boolean): TStringList;
var
  Line,Col : Integer;
  s : string;
begin
  Result := TStringList.Create;
  if IsEmpetyGrid(TempTap) then Exit;

  for Line := 1 to 9 do
    begin
      s:='';
      for Col := 1 to 9 do
        begin
          if (TempTap[Line,Col] = '') then
            begin
              S := S+'0';
              Continue;
            end;
          if (not Bloque[Line,Col]) and (not Sol) then
            begin
              S := S+'0';
              Continue;
            end;
          S := S+ TempTap[Line,Col];
          
        end;
      Result.Add(S);
    end;

end;

procedure TFrGrille.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
  var
    x,y : Integer; // N de (Ligne, colonne) de sous grille : (1..3)
    SS : string;
    CellColor,FontColor : TColor;
    //CurTab : TGrille;
begin
   // choisir le tableau  afficher selon la situation
   {case SuState of
     ssSol,ssSaisie: AffectationTableau(TempTap, CurTab);
     ssSolAu: AffectationTableau(Solution,CurTab) ;
   end;}

   //calculer le N de sous grille : (1..3) pour colorer
   x := (ARow div 3) * 3+ (ACol div 3)+ 1;
   if x mod 2 = 0 then CellColor := clCream else CellColor := clSkyBlue;

   // colorer en clAqua si c'est la cellule courrante
   if gdSelected in State then  CellColor := clAqua;

   SS :=TempTap[ARow+1,ACol+1 ];//SS :=CurTab[ARow+1,ACol+1 ];
   // si la cellule est immodifiable = rouge, si non verte
   if Bloque[ARow+1,ACol+1 ] then FontColor := clRed else FontColor := clGreen;

   StringGrid1.Canvas.Brush.Color := CellColor;
   StringGrid1.Canvas.Font.Color := FontColor;
   StringGrid1.Canvas.Font.Size := 20;
   StringGrid1.Canvas.FillRect(Rect);

   if trim(SS) = '' then Exit;

   // ecrire sur stringgrid
   y := Rect.Top + (StringGrid1.DefaultRowHeight - StringGrid1.Canvas.TextHeight(SS)) DIV 2 ;//((Rect.Bottom - Rect.Top)div 2);
   x := Rect.Left + (StringGrid1.DefaultColWidth - StringGrid1.Canvas.TextWidth(SS)) DIV 2;// + ((Rect.Right - Rect.Left)div 2);
   StringGrid1.Canvas.TextOut(x,y,SS);
end;

procedure TFrGrille.StringGrid1KeyPress(Sender: TObject; var Key: Char);
var
  Selection : TGridRect;
  C,L : Integer;
begin
StatusBar1.Panels[1].Text := '';
Selection:=StringGrid1.Selection;
C := Selection.Left;
L := Selection.Top;
if Bloque[L+1,C+1] then
  begin
    key := #0;
    Beep;
    Exit;
  end;
if SuState = ssSolAu then
  begin
    key := #0;
    Beep;
    Exit;
  end;

if not(key in ['0'..'9']) then
  begin
    key := #0;
    Beep;
    Exit;
  end;


if key = '0' then
  begin
   TempTap[L+1,C+1] := '';
  end else
  begin
   TempTap[L+1,C+1] := Key;
   if not valideContrainte(L+1,C+1,TempTap) then
     begin
        TempTap[L+1,C+1] := '';
        Beep;
        //StringGrid1.Cells[C,L]:= '';
     end else
     begin
        TempTap[L+1,C+1] := Key;
        StringGrid1.Cells[C,L]:= Key;
        if IsFullGrid(TempTap) then
          MessageDlg('Bravo !!'+#10#13+'Solution correcte ',mtInformation,[mbOK],0);
     end;



  end;
 StringGrid1.Repaint;

end;

procedure TFrGrille.StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);

var
  GRect : TGridRect;
  GCoord : TGridCoord;
  ACol,ARow : Integer;
  SCondiddat :string;
  i : Integer;
  MenuItem : TMenuItem;
  PClient,PScreen : TPoint;
begin
  if Button = mbLeft then exit;
  PClient.X := X;
  PClient.Y := Y;
  PScreen := StringGrid1.ClientToScreen(PClient);

  GCoord := StringGrid1.MouseCoord(X,Y);

  ARow := GCoord.y + 1;
  ACol := GCoord.x + 1;

  GRect.Top := ARow - 1;
  GRect.Left := ACol - 1;
  GRect.Bottom := ARow- 1;
  GRect.Right := ACol- 1;

  StringGrid1.Selection := GRect;

  if (ACol < 1) or (ARow < 1) then Exit;

  if Bloque[ARow,ACol] then exit;

  PopupMenu1.Items.Clear;
  SCondiddat := condidat(TempTap,ARow,ACol,'123456789');
  SCondiddat := Trim(SCondiddat);
  if Length(SCondiddat) <= 0 then Exit;

  for I := 1 to Length(SCondiddat) do
    begin
      MenuItem := TMenuItem.Create(PopupMenu1);
      MenuItem.Caption := SCondiddat[i];
      MenuItem.OnClick := MenuItemPopupClik;
      PopupMenu1.Items.Add(MenuItem);
      //MenuItem.Free;
    end;
  MenuItem := TMenuItem.Create(PopupMenu1);
  MenuItem.Caption := '0';
  MenuItem.OnClick := MenuItemPopupClik;
  PopupMenu1.Items.Add(MenuItem);

  
  PopupMenu1.Popup(PScreen.X,PScreen.Y);

  

end;

procedure TFrGrille.StringGrid1MouseLeave(Sender: TObject);
begin
Col := -1; Row := -1;
StringGrid1.Refresh;
end;

procedure TFrGrille.StringGrid1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);

begin
StringGrid1.MouseToCell(X,Y,Col,Row);
StringGrid1.Refresh;
end;

procedure TFrGrille.StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);

var
  SCondidat : string;
begin
   if Bloque[ARow+1, ACol +1] then
     begin
       SCondidat := '';
     end else
     begin
       SCondidat:=Condidat(TempTap,ARow + 1, ACol + 1, '123456789');
     end;
     if Trim(SCondidat)= '' then
       begin
         StatusBar1.Panels[0].Text := '';
       end else
       begin
         StatusBar1.Panels[0].Text := 'Condidats : ' + SCondidat;
       end;
end;

procedure TFrGrille.ViderGrille(var MayTap: TGrille);
var
 Line, Col : Integer;
begin
  for Line := 1 to 9 do
    for Col := 1 to 9 do
      MayTap[Line,Col] := '';
    
end;

procedure TFrGrille.ViderGrilleSol(var MayTap: TGrille);
var
 Line, Col : Integer;
begin
  for Line := 1 to 9 do
    for Col := 1 to 9 do
      if not(Bloque[Line,Col]) then MayTap[Line,Col] := ''; // effacer si n'est pas bloque

end;

end.
